(function() {
	tpl.at = {};
	
	//
	// Add the titles of the test cases to the list to get them loaded to the table view
	//
	tpl.at.createData = function () {
		var acceptanceData = [
		{title:'timob_4487', hasChild:true, level:"acceptance"},
		{title:'timob_5861', hasChild:true, level:"acceptance"},
		{title:'timob_3378', hasChild:true, level:"acceptance"},
		{title:'timob_6143', hasChild:true, level:"acceptance"},
		{title:'timob_6138', hasChild:true, level:"acceptance"},
		{title:'timob_7281', hasChild:true, level:"acceptance"},
		{title:'timob_6711', hasChild:true, level:'acceptance'}
		]
		
		return acceptanceData;
	};
	
	//
	// timob-4487: Expose dragStart and dragEnd on Scroll View
	//


	tpl.at.timob_4487 = function(_window) {
		var scrollView = Ti.UI.createScrollView({
			width : 320,
			height : 480,
			contentWidth : 2000
		});
		scrollView.addEventListener('dragStart', function(e) {
			Ti.API.info('drag start!');
			_window.backgroundColor = '#aaa';
		});
		scrollView.addEventListener('dragEnd', function(e) {
			Ti.API.info('drag end! Will decelerate? ' + (e.decelerate ? 'Yes' : 'No'));
			_window.backgroundColor = '#fff';
		});
		scrollView.add(Ti.UI.createLabel({
			text : 'Swipe Me',
			width : 2000,
			height : 50,
			textAlign : 'left'
		}));
		scrollView.add(Ti.UI.createLabel({
			text : '...and dragStart and dragEnd should fire!',
			width : 2000,
			height : 50,
			textAlign : 'right'
		}));
		_window.add(scrollView);

		return _window;
	}

	
	//
	// timob-5861: iOS: scrollView is not updated correctly.
	//
	
	
	tpl.at.timob_5861 = function(_window) {
		var scrollView = Ti.UI.createScrollView({
			showHorizontalScrollIndicator : true,
			showVerticalScrollIndicator : true,
			width : 250,
			height : 100,
			top : 50,
			borderColor : 'green',
			borderWidth : 1,
			contentWidth : 1000,
			contentHeight : 100
		});

		for(var i = 0; i < 10; i++) {
			for(var j = 0; j < 10; j++) {
				scrollView.add(Ti.UI.createLabel({
					top : i * 100,
					left : j * 100,
					width : 100,
					height : 100,
					text : i + ':' + j,
					textAlign : 'center',
					color : 'white',
					backgroundColor : '#A0' + Number(i % 2 * 8).toString(16) + '0' + Number(8 - j % 2 * 8).toString(16) + '0',
					borderColor : 'black',
					borderWidth : 1
				}));
			}
		}

		var button = Ti.UI.createButton({
			title : 'Flip',
			width : 100,
			height : 50
		});
		button.addEventListener('click', function() {
			scrollView.width = 100;
			scrollView.height = 250;

			scrollView.contentWidth = 100;
			scrollView.contentHeight = 1000;

			button.title = 'Click again';

		});

		scrollView.addEventListener('scroll', function() {
			Ti.API.info('Offset: (' + scrollView.contentOffset.x + ', ' + scrollView.contentOffset.y + ')');
		});
		_window.add(scrollView);
		_window.add(button);

		return _window;
	}
	
	//
	// TIMOB-3378 is designed to test that scrollview.remove() works on Android
	//
	tpl.at.timob_3378 = function(_window) {
		
		var scrollView = Ti.UI.createScrollView({
			layout : 'vertical'
		});

		var label = Ti.UI.createLabel({
			text : 'Test',
			height: 50,
			width : 300,
			color: '#999'
		});

		scrollView.add(label);
		_window.add(scrollView);

		scrollView.addEventListener('click', function() {
			scrollView.remove(label);
		});

		return _window;
	}
	
	//
	// TIMOB-6143 Android: Bottom alignment in ScrollView does not work on Android
	//

	tpl.at.timob_6143 = function(_window) {
		var hull = Ti.UI.createScrollView({
			width : '100%',
			height : '100%',
			backgroundColor : 'blue',
			contentHeight : 'auto',
			contentWidth : 'auto'
		});

		var fixedView = Ti.UI.createView({
			width : '100%',
			height : 30,
			bottom : 0, //this does not work in Android
			backgroundColor : 'green',

		});

		var label1 = Titanium.UI.createLabel({
			color : '#999',
			text : 'I am footer',
			font : {
				fontSize : 20,
				fontFamily : 'Helvetica Neue'
			},
			width : 'auto',
			bottom : 0
		});

		fixedView.add(label1);
		hull.add(fixedView);
		_window.add(hull);
		return _window;
	}



	//
	// timob-6138: Tests that scroll views with labels dorrectly resize when rotating the screen
	//

	tpl.at.timob_6138 = function(_window) {
		
		var scrollview = Titanium.UI.createScrollView({
			contentHeight : 'auto',
			width : 'auto',
			top : 0,
			bottom : 40,
			showVerticalScrollIndicator : true,

		});

		var view = Ti.UI.createView({
			width : 'auto',
			height : 1000
		});

		var label = Ti.UI.createLabel({
			top : 5,
			right : 5,
			left : 5,
			bottom : 5,
			width : 'auto',
			text : "Nel mezzo del cammin di nostra vita mi ritrovai per una selva oscura ché la diritta .... Io cominciai: «Poeta che mi guidi, guarda la mia virtù s'ell'è possente, prima ... a te così com'ella volse; d'inanzi a quella fiera ti levai che del bel monte il corto. ---- Dante Alighieri, detto semplicemente Dante, battezzato come Durante di Alighiero degli Alighieri (Firenze, tra il 22 maggio ed il 13 giugno 1265 – Ravenna, 14 settembre 1321), è stato un poeta, scrittore e politico italiano. Considerato il padre della lingua italiana, è l'autore della Comedìa, divenuta celebre come Divina Commedia ed universalmente considerata la più grande opera scritta in italiano e uno dei più grandi capolavori della letteratura mondiale.[1]Il suo nome, secondo la testimonianza di Jacopo Alighieri, è un ipocoristico di Durante:[2] nei documenti era seguito dal patronimico Alagherii o dal gentilizio de Alagheriis, mentre la variante Alighieri si affermò solo con l'avvento di Boccaccio.[3]È conosciuto come il Sommo Poeta, o, per antonomasia, il Poeta."
		});

		view.add(label);
		scrollview.add(view);
		_window.add(scrollview);


		return _window;
	}

	// TIMOB-7281: test if you can still zoom in or out inside a scrollView

	tpl.at.timob_7281 = function(_window) {
		if(Ti.Platform.osname === 'android') {
			_window.add(tpl.ui.getSkipLabel());
			return _window;
		}
		
		_window.backgroundColor = 'black';
		
		var photosView = Ti.UI.createScrollableView({
		    backgroundColor:'black',
		    width : 320,
		    height : 450,
		    showPagingControl:true,
		    pagingControlHeight:20,
		});
		
		var imgArray = [];
		var img1 = Ti.UI.createImageView({
		    image:'http://media.koreus.com/200606/1image-illusion-optique14-mini.jpg'
		});
		var imgWrapper = Ti.UI.createScrollView({
			maxZoomScale:2.0,
		});
		imgWrapper.add(img1);
		
		imgArray.push(imgWrapper);
		photosView.views = imgArray;
		_window.add(photosView);
		
		return _window;
	};

    /* TIMOB-6711 is designed to test that events in scroll views are handled correctly
     * 
     */
	tpl.at.timob_6711 = function(_window) {
		
		
		
		var button = Ti.UI.createButton({
			title : 'Press me'
		});

		button.addEventListener('click', function() {

			var win = Ti.UI.createWindow({
				backgroundColor : 'white',
				borderColor : 'black',
				borderWidth : 1,
				width : '100%',
				height : '100%',
				navBarHidden : true
			});


			/*
			var button2 = Ti.UI.createButton({
				title : 'close',
				bottom : 10
			});

			button2.addEventListener('click', function(){
				win.close();
			})
            */
			var scrollView = Ti.UI.createScrollView({
				layout : 'vertical',
				height : '90%',
				contentWidth : 'auto',
				contentHeight : 'auto',
				showVerticalScrollIndicator : true,
				touchEnabled : true,
				backgroundColor : 'blue'
			});
			var textLabel = Ti.UI.createLabel({
				color : 'black',
				text : "Tap to fire the singletap event!",
				textAlign : 'left',
				left : 6,
				right : 6,
				top : 6,
				height : 'auto',
				touchEnabled : false
			});
			scrollView.add(textLabel);
			
			win.addEventListener('singletap', function() {
				alert('singletap event fired!');
			});
			
			win.add(scrollView);
			
			
			win.open();
			
		});


		
		_window.add(button);



		return _window;
	};


})();